#include <unistd.h>
#include <sys/wait.h>
#include <stdio.h>
#include "File.c"

int startWorkWithProcess()
{
    QuadraticEquation* muEq = readInputFile(FILE_IN);
    __pid_t pidProcess;
    
        
    switch (pidProcess = fork())
    {
    case -1:
        printf("Что-то пошло не так при создании дочернего процесса\n");
        break;
    case 0: 
        printf("Я клон.\n");
        char* argumentEqInArgv[4];
        for (size_t i = 0; i < 3; i++)
        {
            argumentEqInArgv[i] = calloc(BUFFER, sizeof(char));
        }
    
        sprintf(argumentEqInArgv[0], "%lf", muEq->a); 
        sprintf(argumentEqInArgv[1], "%lf", muEq->b); 
        sprintf(argumentEqInArgv[2], "%lf", muEq->c); 
        argumentEqInArgv[3] = NULL;
        if(execve("Child", argumentEqInArgv, NULL) == -1)
        {
            printf("Что-то пошло не так при создании дочернего процесса\n");
            exit(-1);
        }
        break;

    default:
        printf("Я родитель.\n");
        int statusChild = -1;
        if (wait(&statusChild) == -1)//ожидание завершения дочерних процессов
        {
            printf("Что-то пошло не так при ожидании дочернего процесса\n");
            exit(-1);
        }
        if(statusChild == -1)
        {
            printf("Что-то пошло не так при получении результатов дочернего процесса\n");
            exit(-1);
        }
        if ( WIFEXITED(statusChild) )
        {
            int exit_status = WEXITSTATUS(statusChild);
            printf("Статус выхода дочернего процесса был %d\n", exit_status);
            if(exit_status < 0)
            {
                printf("Что-то пошло не так при получении результатов дочернего процесса\n");
                exit(-1);
            }
            FILE* resFile = fopen(FILE_OUT, "r");
            if(resFile == NULL)
            {
                printf("Что-то пошло не так при получении результатов дочернего процесса\n");
                exit(-1);
            }
            while (!feof(resFile))
            {
                char* str = calloc(BUFFER, sizeof(char));
                fgets(str, BUFFER, resFile);
                puts(str);
            }
            }
        break;
        }
}