/*
1 - работа с файлами
2 - работа с сигналами
3 - создание процессов
4 - работа с потоками
*/
#define WORK_NOW 4

#if(WORK_NOW == 1)
#include "File.c"

#elif(WORK_NOW == 2)
#include <stdio.h>
#include "Signal.c"

#elif(WORK_NOW == 3)
#include "Process.c"

#elif(WORK_NOW == 4)
//#include "ClThread.c"
#endif


int main()
{
    
    /*Работа с файлами*/
    #if(WORK_NOW == 1)
    startWorkWithFile();
    
    #elif(WORK_NOW == 2)
    printf("Это работа с сигналами.\n");
    oldHandler = signal(SIGINT, sigHandler);
    signal(SIGQUIT, sigHandler);
    while(1)
    {
        printf("Я %d и я работаю\n", getpid());
        sleep(1);
        
    }
    #elif(WORK_NOW == 3)
    startWorkWithProcess();
    #endif
    return 0;
}